Index: tmp/org.txm.cah.core/src/org/txm/cah/core/functions/AHC.java
===================================================================
--- tmp/org.txm.cah.core/src/org/txm/cah/core/functions/AHC.java	(revision 0)
+++ tmp/org.txm.cah.core/src/org/txm/cah/core/functions/AHC.java	(revision 528)
@@ -0,0 +1,603 @@
+// Copyright © 2010-2013 ENS de Lyon.
+// Copyright © 2007-2010 ENS de Lyon, CNRS, INRP, University of
+// Lyon 2, University of Franche-Comté, University of Nice
+// Sophia Antipolis, University of Paris 3.
+//
+// The TXM platform is free software: you can redistribute it
+// and/or modify it under the terms of the GNU General Public
+// License as published by the Free Software Foundation,
+// either version 2 of the License, or (at your option) any
+// later version.
+//
+// The TXM platform is distributed in the hope that it will be
+// useful, but WITHOUT ANY WARRANTY; without even the implied
+// warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR
+// PURPOSE. See the GNU General Public License for more
+// details.
+//
+// You should have received a copy of the GNU General
+// Public License along with the TXM platform. If not, see
+// http://www.gnu.org/licenses.
+//
+//
+//
+// $LastChangedDate:$
+// $LastChangedRevision:$
+// $LastChangedBy:$
+//
+package org.txm.cah.core.functions;
+
+import java.io.File;
+import java.util.Arrays;
+
+import org.rosuda.REngine.REXP;
+import org.txm.ca.core.functions.CA;
+import org.txm.cah.core.messages.AHCCoreMessages;
+import org.txm.cah.core.preferences.AHCPreferences;
+import org.txm.chartsengine.core.results.ChartResult;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.TXMParameters;
+import org.txm.lexicaltable.core.functions.LexicalTable;
+import org.txm.statsengine.r.core.RWorkspace;
+import org.txm.statsengine.r.core.exceptions.RWorkspaceException;
+import org.txm.utils.logger.Log;
+
+/**
+ * Agglomerative Hierarchical Clustering.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ *
+ */
+public class AHC extends ChartResult	{
+
+	/** The metric. */
+	String pMetric = "euclidean"; // euclidean, manhattan //$NON-NLS-1$
+
+	/** The method. */
+	String pMethod = "ward"; // METHODS <- c("average", "single", "complete", "ward", "weighted", "flexible") //$NON-NLS-1$
+
+	/** The N cluster. */
+	Integer pNCluster = 3;
+
+	/** if true classify columns values. */
+	Boolean pColumns = true;
+
+	/** The symbol. */
+	String symbol = null;
+
+	/** The CA symbol target. */
+	String target;
+
+	/**
+	 * The coordinates of the clusters.
+	 */
+	protected double[][] clusterCoords = null;
+
+	/**
+	 * The numbers of the clusters.
+	 */
+	protected int[] clusterNumbers = null;
+
+	/**
+	 * The names of the cluster rows.
+	 */
+	protected String[] clusterRowNames = null;
+
+	/**
+	 * The ordered names of the cluster rows.
+	 */
+	protected String[] clusterOrderedRowNames = null;
+
+	/**
+	 * The cluster tree heights.
+	 */
+	protected double[] clusterHeights = null;
+
+	/**
+	 * The cluster tree merges.
+	 */
+	protected double[][] clusterMerges = null;
+
+	/**
+	 * The inertia gains.
+	 */
+	protected double[] inertiaGains = null;
+
+	protected CA ca;
+	protected LexicalTable table;
+
+	/**
+	 * Instantiates a new cAH.
+	 *
+	 * @param ca the ca
+	 * @param col the col
+	 * @param pMethod the method
+	 * @param pMetric the metric
+	 * @param pNCluster the n cluster
+	 * @param display2D the display mode
+	 */
+	public AHC(CA ca)	{
+		super(ca);
+		this.ca = ca;
+		this.table = ca.getLexicalTable();
+		this.target = ca.getSymbol();
+	}
+
+	public void setParameters(Boolean columns, String metric, Integer nCluster, String method) {
+		if (columns != null) this.pColumns = columns;
+		if (metric != null) this.pMetric = metric;
+		if (nCluster != null) this.pNCluster = nCluster;
+		if (method != null) this.pMethod = method;
+		dirty = true;
+	}
+
+	@Override
+	public boolean setParameters(TXMParameters parameters) {
+		this.parameters = parameters;
+		
+		try {
+			Boolean columns = this.getBooleanParameterValue(AHCPreferences.COLUMNS_COMPUTING);
+			String metric = this.getStringParameterValue(AHCPreferences.METRIC);
+			Integer nCluster = this.getIntParameterValue(AHCPreferences.N_CLUSTERS);
+			String method = this.getStringParameterValue(AHCPreferences.METHOD);
+			this.setParameters(columns, metric, nCluster, method);
+		} catch(Exception e) {
+			System.out.println("Error while setting CAH parameters: "+e.getLocalizedMessage());
+			return false;
+		}
+		return true;
+	}
+
+	/**
+	 * Resets the cached data so the next getter calls will request the values from R.
+	 */
+	public void resetCache() {
+		this.clusterCoords = null;
+		this.clusterNumbers = null;
+		this.clusterRowNames = null;
+		this.clusterOrderedRowNames = null;
+		this.clusterHeights = null;
+		this.clusterMerges = null;
+	}
+
+	/**
+	 * Gets the symbol.
+	 *
+	 * @return the symbol
+	 */
+	public String getSymbol() {
+		return symbol;
+	}
+
+	/**
+	 * Gets the methods.
+	 *
+	 * @return the methods
+	 */
+	public static String[] getMethods() {
+		String[] methods = {"average", "single", "complete", "ward", "weighted", "flexible"}; //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$ //$NON-NLS-5$ //$NON-NLS-6$
+		return methods;
+	}
+
+	/**
+	 * Gets the metrics.
+	 *
+	 * @return the metrics
+	 */
+	public static String[] getMetrics() {
+		String[] metrics = {"euclidean", "manhattan"}; //$NON-NLS-1$ //$NON-NLS-2$
+		return metrics;
+	}
+
+	/** The prefix r. */
+	protected static String prefixR = "FactoMineRAHC"; //$NON-NLS-1$
+
+	/** The nocah. */
+	protected static int nocah = 1;
+
+	@Override
+	protected boolean _compute(boolean update)	{
+
+		Log.info("Computing CAH...");
+		try {
+			RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+
+			String colOrLine = "columns"; //$NON-NLS-1$
+			if (!pColumns)
+				colOrLine ="rows"; //$NON-NLS-1$
+
+			if (symbol == null)	{
+				symbol = prefixR+(nocah++);
+			}
+
+			rw.eval("library(FactoMineR)"); //$NON-NLS-1$
+
+
+			rw.eval(symbol +" <- HCPC("+target + //$NON-NLS-1$
+					", cluster.CA=\""+colOrLine+"\"" + //$NON-NLS-1$ //$NON-NLS-2$
+					", nb.clust="+pNCluster + //$NON-NLS-1$
+					", metric=\""+pMetric+"\"" + //$NON-NLS-1$ //$NON-NLS-2$
+					", method=\""+pMethod+"\"" + //$NON-NLS-1$ //$NON-NLS-2$
+					", graph=FALSE)"); //$NON-NLS-1$
+		} catch(RWorkspaceException e) {
+			System.out.println("Failed to compute CAH: "+e);
+			Log.printStackTrace(e);
+			return false;
+		}
+
+		// FIXME: persistence
+		TXMPreferences.putLocalInt(this, AHCPreferences.N_CLUSTERS, this.pNCluster);
+		TXMPreferences.putLocalBoolean(this, AHCPreferences.COLUMNS_COMPUTING, this.pColumns);
+
+		// Reset the cached data
+		this.resetCache();
+		dirty = false;
+		return true;
+	}
+
+	/**
+	 *
+	 * @param outfile
+	 * @param encoding
+	 * @return
+	 */
+	//FIXME: extract to future exporter extension
+	@Deprecated
+	public boolean toTxt(File outfile, String encoding)	{
+		boolean ret = true;
+		acquireSemaphore();
+		RWorkspace rw;
+		try {
+			rw = RWorkspace.getRWorkspaceInstance();
+			rw.eval("sink(file=\"" + outfile.getAbsolutePath().replace("\\", "\\\\")+"\")"); //$NON-NLS-1$ //$NON-NLS-2$ //$NON-NLS-3$ //$NON-NLS-4$
+			rw.eval("print("+symbol+"$call)"); //$NON-NLS-1$ //$NON-NLS-2$
+			rw.eval("sink()"); //$NON-NLS-1$
+		} catch (RWorkspaceException e) {
+			// TODO Auto-generated catch block
+			System.out.println(AHCCoreMessages.ERROR_EXPORT_TXT + e);
+			org.txm.utils.logger.Log.printStackTrace(e);
+			ret = false;
+		} finally {
+			releaseSemaphore();
+		}
+		return true;
+	}
+
+	//FIXME: extract to future exporter extension
+	@Deprecated
+	public boolean toTxt(File outfile, String encoding, String colsep, String txtsep) {
+		return toTxt(outfile, encoding);
+	}
+
+	/**
+	 * Gets the default method.
+	 *
+	 * @return the default method
+	 */
+	public static String getDefaultMethod() {
+		return "ward"; //$NON-NLS-1$
+	}
+
+	/**
+	 * Gets the default metric.
+	 *
+	 * @return the default metric
+	 */
+	public static String getDefaultMetric() {
+		return "euclidean"; //$NON-NLS-1$
+	}
+
+	@Override
+	public void clean() {
+		// TODO Auto-generated method stub
+
+	}
+
+	/**
+	 * Gets the clusters coordinates.
+	 * @return the clusters coordinates
+	 */
+	public double[][] getClusterCoords() {
+		if (this.clusterCoords == null) {
+			try {
+
+				// FIXME: check this code for the CAH 3D chart implementation
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+				for(int i = 0; i < 2; i++) { // 2 dimensions
+					REXP sv = rw.extractItemFromListByName(symbol, "data.clust[,"+ (i + 1)+ "]"); //$NON-NLS-1$
+					double[] coords = RWorkspace.toDouble(sv);
+					for(int j = 0; j < coords.length; j++) {
+						if(this.clusterCoords  == null)	{
+							this.clusterCoords = new double[coords.length][2];
+						}
+						this.clusterCoords[j][i] = coords[j];
+					}
+				}
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.clusterCoords;
+	}
+
+
+	/**
+	 * Gets the clusters numbers.
+	 * @return
+	 */
+	public int[] getClusterNumbers() {
+		if (this.clusterNumbers == null) {
+			try {
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+				// FIXME: not sorted version
+				REXP sv = rw.extractItemFromListByName(symbol, "data$clust"); //$NON-NLS-1$
+				// FIXME: sorted version
+				//REXP sv = rw.extractItemFromListByName(symbol, "data$clust[c(" + symbol + "$call$t$tree$order)]"); //$NON-NLS-1$
+				this.clusterNumbers = sv.asIntegers();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.clusterNumbers;
+	}
+
+	/**
+	 * Gets the cluster row names.
+	 * @return
+	 */
+	public String[] getClusterRowNames() {
+		if (this.clusterRowNames == null) {
+			try {
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+
+				// FIXME: old method, Save the row names in the R data frame
+				//				rw.safeEval(symbol + "$rownames <- rownames(" + symbol + "$data)");
+				//				REXP sv = rw.extractItemFromListByName(symbol, "rownames"); //$NON-NLS-1$
+
+
+				REXP sv = rw.extractItemFromListByName(symbol, "call$t$tree$labels"); //$NON-NLS-1$
+
+
+				this.clusterRowNames = sv.asStrings();
+
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.clusterRowNames;
+	}
+
+
+
+	/**
+	 * Gets the cluster orderer row names.
+	 * @return
+	 */
+	public String[] getClusterOrderedRowNames() {
+		if (this.clusterOrderedRowNames == null) {
+			try {
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+				REXP sv = rw.extractItemFromListByName(symbol, "call$t$tree$labels[c(" + symbol + "$call$t$tree$order)]"); //$NON-NLS-1$
+				this.clusterOrderedRowNames = sv.asStrings();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.clusterOrderedRowNames;
+	}
+
+
+	/**
+	 * Gets the cluster tree heights.
+	 * @return
+	 */
+	public double[] getClusterTreeHeights() {
+		if (this.clusterHeights == null) {
+			try {
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+				REXP sv = rw.extractItemFromListByName(symbol, "call$t$tree$height"); //$NON-NLS-1$
+				this.clusterHeights = sv.asDoubles();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.clusterHeights;
+	}
+
+
+	/**
+	 * Gets the inertia gains.
+	 * @return
+	 */
+	// FIXME: for test purpose, this method is not used for the chart computing
+	public double[] getInertiaGains() {
+		if (this.inertiaGains == null) {
+			try {
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+				REXP sv = rw.extractItemFromListByName(symbol, "call$t$inert.gain"); //$NON-NLS-1$
+				// FIXME: tests
+				//			REXP sv = rw.extractItemFromListByName(symbol, "call$t$within"); //$NON-NLS-1$
+
+				this.inertiaGains = sv.asDoubles();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.inertiaGains;
+	}
+
+
+	/**
+	 * Gets the cluster tree merges.
+	 * @return
+	 */
+	public double[][] getClusterTreeMerges() {
+		if (this.clusterMerges == null) {
+			try {
+				RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+				REXP sv = rw.extractItemFromListByName(symbol, "call$t$tree$merge"); //$NON-NLS-1$
+				this.clusterMerges = sv.asDoubleMatrix();
+			}
+			catch (Exception e) {
+				// TODO Auto-generated catch block
+				org.txm.utils.logger.Log.printStackTrace(e);
+			}
+		}
+		return this.clusterMerges;
+	}
+
+
+
+
+
+
+	/**
+	 * Sets the metric to use for computing.
+	 * @param metric the metric to set
+	 */
+	public void setMetric(String metric) {
+		this.pMetric = metric;
+	}
+
+	/**
+	 * Sets the method to use for computing
+	 * @param method the method to set
+	 */
+	public void setMethod(String method) {
+		this.pMethod = method;
+	}
+
+	/**
+	 * Sets the computing to columns or rows.
+	 * @param columns the columns to set
+	 */
+	public void setColumnsComputing(boolean columns) {
+		this.pColumns = columns;
+	}
+
+	/**
+	 * Sets the number of clusters to use for computing
+	 * @param nCluster the nCluster to set
+	 */
+	public void setNCluster(int nCluster) {
+		pNCluster = nCluster;
+	}
+
+	/**
+	 * Checks if the computing mode is set as columns. If not, the computing mode is set as rows.
+	 * @return the columns
+	 */
+	public boolean isColumnsComputing() {
+		return pColumns;
+	}
+
+	/**
+	 * Gets the maximum clusters available according to the current computing mode (columns or rows) and according to current source (<code>CA</code> or <code>LexicalTable</code>).
+	 * The maximum numbers of available clusters is for now limited to 16 by this method due of a limitation of FactoMineR plot.HCPC().
+	 * @return the maximum clusters available according to the current computing mode
+	 */
+	public int getMaxClustersCount()	{
+
+		int maxClustersCount = -1;
+
+		try {
+			RWorkspace rw = RWorkspace.getRWorkspaceInstance();
+			REXP sv = rw.eval("min(length(" + symbol + "$data$clust) - 1, 16)"); //$NON-NLS-1$ //$NON-NLS-2$
+			maxClustersCount = sv.asInteger();
+		} catch(Exception e) {
+			System.out.println("Error: "+e.getLocalizedMessage());
+			Log.printStackTrace(e);
+		}
+
+		// FIXME: FactoMineR plot.HCPC doesn't manage more than 16 clusters when tree.barplot=TRUE, therefore we can't plot a SVG with more than that, see ticket #836 then use the code below in ChartsEngine to compute
+		// the real maximum available clusters count
+		//		// CA
+		//		if(this.source instanceof CA)	{
+		//			if(this.columns == true)	{
+		//				maxClustersCount = ((CA)this.source).getColumnsCount() - 1;
+		//			}
+		//			else	{
+		//				maxClustersCount = ((CA)this.source).getRowsCount() - 1;
+		//			}
+		//		}
+		//		// Lexical table
+		//		else if(this.source instanceof LexicalTable)	{
+		//			if(this.columns == true)	{
+		//				maxClustersCount = ((LexicalTable)this.source).getColumnsCount() - 1;
+		//			}
+		//			else	{
+		//				maxClustersCount = ((LexicalTable)this.source).getRowsCount() - 1;
+		//			}
+		//		}
+
+		return maxClustersCount;
+	}
+
+
+
+	@Override
+	public String[] getExportTXTExtensions() {
+		return new String[]{"*.txt"};
+	}
+
+
+	/**
+	 * Returns the number of clusters.
+	 * @return the nCluster
+	 */
+	public int getNCluster() {
+		return pNCluster;
+	}
+
+	public CA getCA() {
+		return ca;
+	}
+
+	public LexicalTable getLexicalTable() {
+		return table;
+	}
+
+
+	@Override
+	public String getName() {
+		return getParent().getName();
+	}
+
+
+	@Override
+	public String getSimpleName() {
+		StringBuffer buffer = new StringBuffer();
+		if (pColumns != null) buffer.append(pColumns?"cols":"rows");
+		if (pMethod != null) buffer.append(" "+pMethod);
+		if (pMetric != null) buffer.append(" "+pMetric);
+		if (pNCluster != null) buffer.append(" "+pNCluster);
+		return this.getName();
+	}
+
+	@Override
+	public String getDetails() {
+		return this.getName();
+	}
+
+	@Override
+	public boolean canCompute() {
+
+		return ca != null 
+				&& Arrays.binarySearch(AHC.getMethods(), pMethod) >= 0 
+				&& Arrays.binarySearch(AHC.getMetrics(), pMetric) >= 0
+				&& pNCluster >= 2;
+	}
+}

Index: tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/r/RAHCChartCreator.java
===================================================================
--- tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/r/RAHCChartCreator.java	(revision 0)
+++ tmp/org.txm.cah.core/src/org/txm/cah/core/chartsengine/r/RAHCChartCreator.java	(revision 528)
@@ -0,0 +1,56 @@
+package org.txm.cah.core.chartsengine.r;
+
+import java.io.File;
+
+import org.txm.cah.core.functions.AHC;
+import org.txm.cah.core.preferences.AHCPreferences;
+import org.txm.core.preferences.TXMPreferences;
+import org.txm.core.results.TXMResult;
+import org.txm.chartsengine.r.core.RChartCreator;
+
+/**
+ * R CAH chart creator.
+ * 
+ * @author mdecorde
+ * @author sjacquot
+ *
+ */
+public class RAHCChartCreator extends RChartCreator {
+
+
+	@Override
+	public File createChartFile(TXMResult result, File file) {
+
+		AHC cah = (AHC) result;
+		
+		String cmd = null;
+		// 2D
+		if (result.getBooleanParameterValue(AHCPreferences.DISPLAY_2D)) {
+			cmd = "plot.HCPC(" + cah.getSymbol() + ", new.plot=FALSE, choice=\"tree\")";
+			
+		// FIXME: for tests without drawing the inertia barplot. Without it, the max available clusters can exceed 16
+		//cmd = "plot.HCPC(" + cah.getSymbol() + ", new.plot=FALSE, choice=\"tree\", tree.barplot=FALSE)"; //$NON-NLS-1$ //$NON-NLS-2$
+		// FIXME: Tests for drawing only the inertia bar plot. We may need to create a method for this : createCAHIntertiaChart() in the charts engines
+		//cmd= "plot.HCPC(" + cah.getSymbol() + ", new.plot=FALSE, choice=\"bar\")"; //$NON-NLS-1$ //$NON-NLS-2$
+
+			
+		}
+		// 3D
+		else {
+			cmd = "plot.HCPC("+ cah.getSymbol() +", new.plot=FALSE)";
+		}
+		
+		this.getChartsEngine().plot(file, cmd);
+		
+		return file;
+	}
+
+	
+	@Override
+	public Class getResultDataClass() {
+		return AHC.class;
+	}
+
+
+
+}

Index: tmp/org.txm.cah.core/META-INF/MANIFEST.MF
===================================================================
--- tmp/org.txm.cah.core/META-INF/MANIFEST.MF	(revision 527)
+++ tmp/org.txm.cah.core/META-INF/MANIFEST.MF	(revision 528)
@@ -1,6 +1,6 @@
 Manifest-Version: 1.0
 Bundle-ManifestVersion: 2
-Bundle-Name: CAH Core
+Bundle-Name: AHC Core
 Bundle-SymbolicName: org.txm.cah.core;singleton:=true
 Bundle-Version: 1.0.0.qualifier
 Require-Bundle: org.txm.utils;bundle-version="1.0.0";visibility:=reexport,
Index: tmp/org.txm.internalview.rcp/src/org/txm/internal/rcp/editors/InternalViewEditor.java
===================================================================
--- tmp/org.txm.internalview.rcp/src/org/txm/internal/rcp/editors/InternalViewEditor.java	(revision 527)
+++ tmp/org.txm.internalview.rcp/src/org/txm/internal/rcp/editors/InternalViewEditor.java	(revision 528)
@@ -140,10 +140,10 @@
 				JobsTimer.start();
 				monitor.beginTask(Messages.InternalViewEditor_2, 100);
 				try {
-					if (!(internalView.validateParameters() && internalView.isDirty()))
+					if (!(internalView.canCompute() && internalView.isDirty()))
 						return Status.CANCEL_STATUS;
 
-					internalView.compute(monitor);
+					internalView.compute(false, monitor);
 					firePropertyChange(PROP_DIRTY); // refresh the dirtiness state
 					line = internalView.getCurrentPage(); // get the first page if pCurrentPage is not set
 					monitor.beginTask(Messages.InternalViewEditor_3, 100);
